SystemOrganization addCategory: #'Moe-Model'!
SystemOrganization addCategory: #'Moe-Magritte'!
SystemOrganization addCategory: #'Moe-Seaside'!
SystemOrganization addCategory: #'Moe-Tests'!

!String methodsFor: '*moe' stamp: 'jmck 6/9/2009 10:31'!
asIntegerArray
	^(self allButFirst allButLast subStrings: #($,)) 
			collect: [ :string | Number readFrom: (ReadStream on: string) ]! !

MAPriorityContainer subclass: #MOEmbeddedContainer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedContainer commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I exist to point to an MOEmbeddedContainerComponent which saves the model to the DB after commiting the memento to the model.!

!MOEmbeddedContainer methodsFor: 'accessing' stamp: 'jmck 6/9/2009 19:19'!
componentClass
	^MOEmbeddedContainerComponent! !

!MOEmbeddedContainer methodsFor: 'accessing' stamp: 'jmck 6/12/2009 21:27'!
componentRenderer
	^MORowRenderer! !

MAComponentRenderer subclass: #MORowRenderer
	instanceVariableNames: 'rows columns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 7/7/2009 07:18'!
renderContainer: aDescription
	| description rowcount | 
	description := aDescription select: [ :each | each isVisible ].
	rowcount := description children last priority // 10.
		
	rows := OrderedCollection ofSize: 0.
	(0 to: rowcount) do: [ :row | | coll |
		(coll := description select: [ :each | each priority // 10 = row ]) size > 0 
			ifTrue: [ rows add: coll ] ].		
		
	columns := rows inject: 0 into: [ :cols :row | cols max: row children size  ].

	html table
		class: (self classFor: aDescription);
		with: [
			rows do: [ :each | self renderRow: each ]]
	
	! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 7/3/2009 11:55'!
renderRow: aCollection
	html tableRow: [ self renderRowLabels: aCollection ].
	html tableRow: [ self renderRowValues: aCollection ].
! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 7/4/2009 12:58'!
renderRowLabels: aCollection
	| span |
	span := columns // aCollection size.
	aCollection do: [ :each | 
			html tableData colSpan: span; with: [ html label: each label ] ] ! !

!MORowRenderer methodsFor: 'rendering' stamp: 'jmck 7/1/2009 22:43'!
renderRowValues: aCollection
	| span |
	span := columns // aCollection size.
	aCollection do: [ :each | 
		html tableData colSpan: span; with: [ super renderControl: each ] ]
	"aCollection do: [ :each | (each isEmbeddedCollection or: [aCollection size = 1])
		ifTrue: [ html tableData colSpan: columnspan; with: [ super renderControl: each ] ]
		ifFalse: [ html tableData: [ super renderControl: each ] ] ]"
	! !

MAToOneRelationDescription subclass: #MOEmbeddedObjectDescription
	instanceVariableNames: 'objectClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedObjectDescription commentStamp: 'jmck 6/12/2009 14:57' prior: 0!
I am a convenience description. I return true for isEmbedded ao you don;t have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

I do implement componentClass which returns a nifty lookup component.

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:23'!
componentClass
	^MOSelectEmbeddedComponent! !

!MOEmbeddedObjectDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:51'!
isEmbedded
	^true! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/11/2009 23:09'!
objectClass
	"Answer the value of objectClass"

	^ objectClass ifNil: [ self classes first ]! !

!MOEmbeddedObjectDescription methodsFor: 'accessing' stamp: 'jmck 6/13/2009 13:12'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
		classes isNil
			ifTrue: [classes := Array with: aClass]
			ifFalse: [ classes := (Array with: aClass) addAll: classes ].! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
beEmbedded
	self propertyAt: #embedded put: true! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
beEmbeddedCollection
	self propertyAt: #embeddedCollection put: true! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
isEmbedded
	^self propertyAt: #embedded ifAbsent: [ false ]! !

!MADescription methodsFor: '*moe' stamp: 'jmck 6/8/2009 20:59'!
isEmbeddedCollection
	^self propertyAt: #embeddedCollection ifAbsent: [ false ]! !

!Collection methodsFor: '*moe' stamp: 'jmck 6/12/2009 14:02'!
asIntegerArrayString
	"collection elements must respond to id, i.e. MAMappedObject"
	^String streamContents: [ :s | 
		s nextPut: ${;
		nextPutAll: (self collect: [ :each | each id ]) asCommaString;
		nextPut: $} ]! !

TestCase subclass: #MOEmbeddedObjectTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 22:11'!
setUp
	object := MOMockObject new. 
	object embedded add: (MOMockSubObject new
				privateId: 1; 
				field1: 1; 
				field2: 2; 
				field3: 3; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 2; 
				field1: 2; 
				field2: 3; 
				field3: 4; 
				yourself).
	object embedded add: (MOMockSubObject new 
				privateId: 3; 
				field1: 3; 
				field2: 4; 
				field3: 5; 
				yourself).
			! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 22:14'!
testAttributeValueFor
	self assert: [ (object attributeValueFor: 'field1') = '1'].
	self assert: [ (object attributeValueFor: 'field2') = 100 ].
	self assert: [ (object attributeValueFor: 'field3') = '2'].
	self assert: [ (object attributeValueFor: 'embedded') = '{1, 2, 3}'].
	self assert: [ (object attributeValueFor: 'scalar') isNil ].! !

!MOEmbeddedObjectTest methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:57'!
testMappedDescription
	self assert: [ object mappedDescription children size = 5 ].
! !

MAOneToManyComponent subclass: #MOOneToManyComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOOneToManyComponent methodsFor: 'actions' stamp: 'jmck 7/7/2009 22:37'!
add
	| result |
	"first validate do we can commit (and save to the db) safely on return if an embedded child is added"
	parent validate ifFalse: [ ^ self ].
	result := self selected new.
	result := self root call: (result asComponent
		addMessage: 'Add ' , self selected label;
		addValidatedForm;
		yourself).
	result isNil
		ifFalse: [ self value: (self value copyWith: result). 
			self parent commit.
			self parent model save.
			self refresh ]! !

!MOOneToManyComponent methodsFor: 'actions' stamp: 'jmck 7/4/2009 12:51'!
remove: anEmbeddedObject
	"One may definitely want to override delete if they want more control over whether or not 
	it should really be removed from the database, i.e. checking to see if anyone else is referring to it"
	
	anEmbeddedObject delete.
	super remove: anEmbeddedObject.
	parent save
! !

!MOOneToManyComponent methodsFor: 'rendering' stamp: 'jmck 7/5/2009 00:46'!
renderViewerOn: html
	html div 
		class: self description label;
		with: [ super renderViewerOn: html ]! !

MAExternalEditorComponent subclass: #MOSelectEmbeddedComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOSelectEmbeddedComponent commentStamp: 'jmck 6/12/2009 08:41' prior: 0!
An embeddedobject lookup component
Good for one-to-one object lookup, renders the create button to add a new lookup object to the lookup list.!

!MOSelectEmbeddedComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/28/2009 09:17'!
renderEditorOn: html
	self renderSelectListOn: html.
	super renderSelectButtonOn: html.! !

!MOSelectEmbeddedComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/26/2009 22:11'!
renderSelectListOn: html
	| instances | 
	(instances := self selected list) isEmpty
		ifFalse: [ 
			html select
				list: ((Array with: nil) , instances);
				selected: self value;
				callback: [ :value | value ifNotNil: [ self value: value ] ]]
		ifTrue: [ html text: ('No ' , self selected asString allButFirst: 2) ]
! !

!MOSelectEmbeddedComponent methodsFor: 'as yet unclassified' stamp: 'jmck 6/11/2009 23:22'!
renderViewerOn: html
	self renderEditorOn: html! !

MAContainerComponent subclass: #MOEmbeddedContainerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Seaside'!

!MOEmbeddedContainerComponent methodsFor: 'actions' stamp: 'jmck 6/9/2009 11:42'!
save
	self validate ifFalse: [ ^ self ].
	self commit.
	self model save.
	self answer: self model.! !

MAToManyRelationDescription subclass: #MOEmbeddedCollectionDescription
	instanceVariableNames: 'objectClass collectionClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Magritte'!

!MOEmbeddedCollectionDescription commentStamp: 'jmck 6/12/2009 14:59' prior: 0!
I am a convenience description. I return true for isEmbeddedCollection so you don't have of to send beEmbeddedCollection (but you still have to type EmbeddedCollection!!). I also have a useless objectClass method that is supposed to be a convenience but only serves to confuse issues further lol

The author is still deciding whether or not to toss me like he has the rest of his bloated framework!

!MOEmbeddedCollectionDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 6/12/2009 15:09'!
defaultCollectionClass
	^OrderedCollection! !

!MOEmbeddedCollectionDescription class methodsFor: 'as yet unclassified' stamp: 'jmck 6/27/2009 23:23'!
defaultComponentClasses
	^Array with: MOOneToManyComponent! !

!MOEmbeddedCollectionDescription methodsFor: 'testing' stamp: 'jmck 6/12/2009 14:52'!
isEmbeddedCollection
	^true! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 7/4/2009 12:30'!
objectClass
	^objectClass ifNil: [^self classes first ]! !

!MOEmbeddedCollectionDescription methodsFor: 'accessing' stamp: 'jmck 6/13/2009 13:39'!
objectClass: aClass
	"Set the value of objectClass"

	objectClass := aClass.
	classes isNil 
		ifTrue: [ classes := (Array with: aClass) ]
		ifFalse: [ classes := (Array with: aClass) addAll: classes ]! !

MAMappedObject subclass: #MOEmbeddedObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

!MOEmbeddedObject commentStamp: 'jmck 6/12/2009 11:10' prior: 0!
Moe is a simple object persistency strategy using Magritte and Roe - Moe!!
The main architectural feature is that Moe make the database "mirror" the Smalltalk objects rather than force the objects to adhere to all sorts of strangulations like pesky foreign key definitions and the like. 

The base class, MOEmbeddedObject,  is a descendant of MAMappedObject. All persisting objects must descend from MOEmbeddedObject and override loadEmbeddedObjectFor: aDescription withId: anId. MODatalistObject and MODatabaseObject are two classes from which you can descend "out of the box". Datalists keep a list of ALL of its instances in a class variable. The latter loads only the objects as they are referenced. 


Describe an embedded object 'Customer' like so:
descriptionCustomer
	^MOEmbeddedObjectDescription new
		objectClass: Customer; 
		embeddedAccessor: #customer;
		label: 'Customer';
		sqlColumnName: 'customer';
		sqlColumnType: 'integer';
		priority: 10;
		yourself
		
When a Moe described objects will have their ID stored in the database in the column where the object should be, and on retrieval from the DB it will be restored with the Smalltalk object. Collections will have an array of integers stored in the DB from which the collection will be restored upon retrieval.

This is pretty lightweight (I think), and is meant only as a means of persistency (read: data backup and restore)
!

MOEmbeddedObject subclass: #MODatabaseObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

!MODatabaseObject commentStamp: 'jmck 6/11/2009 18:00' prior: 0!
I am like the Datalist object but I don't load all of the insances of me from the database.!

!MODatabaseObject methodsFor: 'persistence' stamp: 'jmck 6/12/2009 14:47'!
loadEmbeddedObjectFor: aDescription withID: anId
	"This can be overridden if you would rather hit the database for each embedded object
	The current implementation uses uses a class variable to store ALL objects from the DB"
	
	 ^ aDescription classes first loadId: anId! !

MOEmbeddedObject subclass: #MODatalistObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Model'!

MODatalistObject class
	instanceVariableNames: 'List'!

!MODatalistObject commentStamp: 'jmck 6/11/2009 17:58' prior: 0!
I am really an example class of one way to maintain the database of objects in the image. I load all the instances of me in a List variable!

MODatalistObject class
	instanceVariableNames: 'List'!

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/5/2009 14:32'!
initialize
	Smalltalk addToStartUpList: self; addToShutDownList: self! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/3/2009 16:48'!
list
	
	List ifNil: 
	
		[ [ (List := SortedCollection sortBlock: [ :a :b | a id < b id ]) addAll: self loadAll ]
		
		
		on: Error do: [ :ex | List := nil ] ].
	^List! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 6/13/2009 12:49'!
reset
	List := nil! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/5/2009 14:24'!
shutDown
	self allSubclasses do: [ :each | each reset ]! !

!MODatalistObject class methodsFor: 'persistency' stamp: 'jmck 7/5/2009 14:25'!
startUp
	self shutDown.
	self allSubclasses do: [ :each | each list ]! !

!MODatalistObject methodsFor: 'private-sql' stamp: 'jmck 6/9/2009 19:46'!
insert
	super insert.
	self list add: self.! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 6/9/2009 19:36'!
list
	^self class list! !

!MODatalistObject methodsFor: 'persistence' stamp: 'jmck 7/3/2009 10:37'!
loadEmbeddedObjectFor: aDescription withId: anId
	^ aDescription objectClass list detect: [ :each | each id = anId ] ifNone: [ nil ]! !

!MOEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/9/2009 19:19'!
descriptionContainer
	^MOEmbeddedContainer new! !

!MOEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/8/2009 20:44'!
load: aRelation
	^ (super load: aRelation) do: [ :each | each loadEmbedded ].
	! !

!MOEmbeddedObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/9/2009 19:40'!
loadId: anId
	^(super loadId: anId) loadEmbedded! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/18/2009 21:08'!
attributeValueFor: aColumnName
	| desc value |
	desc := self description detect: [ :each | each sqlColumnName = aColumnName ] ifNone: [ ^nil ].
	((value := self readUsing: desc) isNil or: [
		(desc isEmbedded or: [ desc isEmbeddedCollection ]) not ])
		ifTrue: [ ^value ].
	^desc isEmbedded 
		ifTrue: [ value id ]
		ifFalse: [ value asIntegerArrayString ]
			! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/17/2009 06:44'!
insert
	| descriptions result value |
	descriptions := self mappedDescription children
		copyWithout: self class descriptionId.
	result := self relation basicQuery: (self relation
		sqlInsert: (descriptions collect: [ :each | each sqlColumnName  ])
		values: (descriptions collect: [ :each | 
			(((value := self readUsing: each) isNil) or: [
				(each isEmbedded or: [ each isEmbeddedCollection]) not ])
			ifTrue: [ value ]
			ifFalse: [
				each isEmbedded 
					ifTrue: [ value id ]
					ifFalse: [ value asIntegerArrayString ]]])) , ';' ,
		(self relation sqlCurrentValue: self class descriptionId sqlColumnName).
	id := result first first.
! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 17:45'!
loadEmbedded
	self description do: [ :desc |
		desc isEmbedded 
			ifTrue: [ self loadEmbeddedDescription: desc ]
			ifFalse: [
				desc isEmbeddedCollection 
					ifTrue: [ 
						self loadEmbeddedCollectionDescription: desc ]]].
! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/13/2009 12:58'!
loadEmbeddedCollectionDescription: aDescription
	"Read the string representation of the integer array returned by postgres, convert it and retrieve the objects
	replacing the string with the ressurected collection"
	
	| ids embeddedObjects |	
	embeddedObjects := SortedCollection sortBlock: [ :a :b | a id < b id ].
	ids := self readUsing: aDescription.
	(ids notNil and: [ ids size > 2 ]) 
			ifTrue: [
				(ids asIntegerArray)
					inject: embeddedObjects
					into: [ :collection :i | 
						collection add: (self loadEmbeddedObjectFor: aDescription withId: i); yourself]].
	aDescription accessor write: embeddedObjects to: self ! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/13/2009 12:48'!
loadEmbeddedDescription: aDescription
	| embeddedid |
	(embeddedid := self readUsing: aDescription) isNil
		ifFalse: [
			aDescription accessor
				write: (self loadEmbeddedObjectFor: aDescription withId: embeddedid)
				to: self ]! !

!MOEmbeddedObject methodsFor: 'persistence' stamp: 'jmck 6/11/2009 18:35'!
loadEmbeddedObjectFor: aDescription withId: anId
	"This can be overridden if you would rather hit the database for each embedded object
	The current implementation uses uses a class variable to store ALL objects from the DB"
	
	 self subclassResponsibility! !

MOEmbeddedObject subclass: #MOMockObject
	instanceVariableNames: 'field1 field2 field3 embedded scalar'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:24'!
description1
	^MAStringDescription new
		accessor: #field1;
		label: 'field1';
		sqlColumnName: 'field1';
		sqlColumnType: 'text';
		priority: 10;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 22:10'!
description2
	^MOEmbeddedObjectDescription new
		accessor: #field2;
		label: 'field2';
		sqlColumnName: 'field2';
		sqlColumnType: 'integer';
		priority: 11;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:44'!
description3
	^MAStringDescription new
		accessor: #field3;
		label: 'field3';
		sqlColumnName: 'field3';
		sqlColumnType: 'text';
		priority: 12;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:25'!
descriptionEmbedded
	^MOEmbeddedCollectionDescription new
		accessor: #embedded;
		label: 'embedded';
		sqlColumnName: 'embedded';
		sqlColumnType: 'integer[]';
		priority: 11;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:28'!
descriptionScalar
	^MAStringDescription new
		accessor: #scalar;
		label: 'scalar';
		priority: 14;
		yourself! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:45'!
tableName
	^'test'! !

!MOMockObject class methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 21:55'!
testMappedDescription
	self assert: [ self mappedDescription size = 5 ].
! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded
	"Answer the value of embedded"

	^ embedded! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
embedded: anObject
	"Set the value of embedded"

	embedded := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/12/2009 15:36'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !

!MOMockObject methodsFor: 'as yet unclassified' stamp: 'jmck 6/18/2009 22:06'!
initialize
	field1 := '1'.
	field2 := MOMockSubObject new privateId: 100.
	field3 := '2'.
	embedded := OrderedCollection new.
! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:28'!
scalar
	"Answer the value of scalar"

	^ scalar! !

!MOMockObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:28'!
scalar: anObject
	"Set the value of scalar"

	scalar := anObject! !

MOEmbeddedObject subclass: #MOMockSubObject
	instanceVariableNames: 'field1 field2 field3'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moe-Tests'!

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field1
	"Answer the value of field1"

	^ field1! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field1: anObject
	"Set the value of field1"

	field1 := anObject! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field2
	"Answer the value of field2"

	^ field2! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field2: anObject
	"Set the value of field2"

	field2 := anObject! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field3
	"Answer the value of field3"

	^ field3! !

!MOMockSubObject methodsFor: 'accessing' stamp: 'jmck 6/18/2009 21:11'!
field3: anObject
	"Set the value of field3"

	field3 := anObject! !
MODatalistObject initialize!
